include:
  - project: 'digit-c4/dev/best-practices'
    file: 'gitlab-ci/test-static-scan.yml'
    ref: main
  - project: 'digit-c4/dev/python-best-practices'
    file: 'gitlab-ci/test-static-style-force.yml'
    ref: main
  - project: 'digit-c4/dev/python-best-practices'
    file: 'gitlab-ci/test-static-style-check.yml'
    ref: main

stages:
  - test

test-static-scan-gitleaks:
  stage: test
  tags:
    - docker
    - lab

test-static-style-force-job:
  stage: test
  tags:
    - docker
    - lab
  variables:
    CI_JOB_TOKEN_WRITE: ${CI_TOKEN_WRITE}
    SRC_PATH: src

test-static-style-check-job:
  stage: test
  tags:
    - docker
    - lab
  variables:
    SRC_PATH: src

test-unit-job:
  stage: test
  tags:
    - docker
    - lab
  image: code.europa.eu:4567/digit-c4/dev/python-best-practices/python-poetry:3.11-alpine
  before_script:
    - poetry install --with test --sync
  script:
    - poetry run pytest src/tests/unit

test-integration-job:
  stage: test
  tags:
    - shell
    - lab
  image: code.europa.eu:4567/digit-c4/dev/python-best-practices/python-poetry:3.11-alpine
  before_script:
    - poetry install --with test --sync
  script:
    - poetry run pytest src/tests/integration
